package com.amazon.aws.buildersflash.schoolmailsearch;

import org.apache.http.HttpHost;
import org.apache.http.HttpRequestInterceptor;
import org.elasticsearch.client.RestClient;
import org.elasticsearch.client.RestHighLevelClient;

import com.amazonaws.auth.AWS4Signer;
import com.amazonaws.auth.DefaultAWSCredentialsProviderChain;
import com.amazonaws.http.AWSRequestSigningApacheInterceptor;

abstract class AbstractFunction {
    protected static final String INDEX_NAME = System.getenv("INDEX_NAME");
    protected static final String REGION = System.getenv("REGION");
    protected static final String AES_ENDPOINT = "https://" + System.getenv("AES_ENDPOINT");

    protected static final RestHighLevelClient ES_CLIENT;
    static {
        AWS4Signer signer = new AWS4Signer();
        signer.setServiceName("es");
        signer.setRegionName(REGION);
        HttpRequestInterceptor interceptor = new AWSRequestSigningApacheInterceptor(signer.getServiceName(), signer,
                new DefaultAWSCredentialsProviderChain());
        ES_CLIENT = new RestHighLevelClient(RestClient.builder(HttpHost.create(AES_ENDPOINT))
                .setHttpClientConfigCallback(hacb -> hacb.addInterceptorLast(interceptor)));
    }
}
